unit DrawPic;

interface

Uses
    Types,Graph,Setting,Crt,intro;

procedure DrawBackPic;
function BoundScorePic(num:integer; var Match:typeMATCH_STATE; var Rect:typeRECTANGLE):BOOLEAN;
procedure DrawScorePic(num:integer; var Match:typeMATCH_STATE);
function BoundInfoPic(num:integer; var Match:typeMATCH_STATE; var Rect:typeRECTANGLE):BOOLEAN;
procedure DrawInfoPic(num:integer; var Match:typeMATCH_STATE);
function BoundPlayerPic(num:integer; var Match:typeMATCH_STATE; var Rect:typeRECTANGLE):BOOLEAN;
procedure DrawPlayerPic(num:integer; var Match:typeMATCH_STATE);
function BoundBallPic(num:integer; var Match:typeMATCH_STATE; var Rect:typeRECTANGLE):BOOLEAN;
procedure DrawBallPic(num:integer; var Match:typeMATCH_STATE);
function BoundDebugPlayer(num:integer; var Match:typeMATCH_STATE; var Rect:typeRECTANGLE):BOOLEAN;
procedure DrawDebugPlayer(num:integer; var Match:typeMATCH_STATE);
function BoundDebugEvent(num:integer; var Match:typeMATCH_STATE; var Rect:typeRECTANGLE):BOOLEAN;
procedure DrawDebugEvent(num:integer; var Match:typeMATCH_STATE);
function BoundDebugJudge(num:integer; var Match:typeMATCH_STATE; var Rect:typeRECTANGLE):BOOLEAN;
procedure DrawDebugJudge(num:integer; var Match:typeMATCH_STATE);
function BoundDebugWhereBall(num:integer; var Match:typeMATCH_STATE; var Rect:typeRECTANGLE):BOOLEAN;
procedure DrawDebugWhereBall(num:integer; var Match:typeMATCH_STATE);

implementation

var pPics:array[1..MAX_PLAYERS] of pointer;
    strN:string;
    i:integer; { fucking pascal }
    size:word;
    InFile:file;


procedure t( x,y,z:real; var ox,oy:integer );
var ptx,pty,k,h,w,axs,my,mx:real;
begin
  ox := trunc(y*22+60);
  oy := trunc(x*22+60);
end;

function d( x:real ):integer;
begin
     d := trunc(x*22);
end;

procedure tRectangle( x1,y1,x2,y2:real );
var x,y:integer;
begin
    t(x1,y1,0,x,y);
    MoveTo(x,y);
    t(x1,y2,0,x,y);
    LineTo(x,y);
    t(x2,y2,0,x,y);
    LineTo(x,y);
    t(x2,y1,0,x,y);
    LineTo(x,y);
    t(x1,y1,0,x,y);
    LineTo(x,y);
end;

procedure DrawBackPic;
var i,x,y,x1,y1:integer;
begin
    cleardevice;
    readobr('ground.pic');
end;

function BoundScorePic(num:integer; var Match:typeMATCH_STATE; var Rect:typeRECTANGLE):BOOLEAN;
begin
     Rect.x1 := 300;
     Rect.y1 := 400;
     Rect.x2 := 630;
     Rect.y2 := 410;
     BoundScorePic := TRUE;
end;

procedure DrawScorePic(num:integer; var Match:typeMATCH_STATE);
var p1,p2,g1,g2,s1,s2:STRING;
begin
   setcolor(11);
   str(Match.Score.points[1],p1);
   str(Match.Score.points[2],p2);
   str(Match.Score.Games[1],g1);
   str(Match.Score.Games[2],g2);
   str(Match.Score.Sets[1],s1);
   str(Match.Score.Sets[2],s2);
   OutTextXY(300,400,'Sets '+s1+':'+s2+'  Games '+g1+':'+g2+'  Points '+p1+':'+p2);
end;

function BoundInfoPic(num:integer; var Match:typeMATCH_STATE; var Rect:typeRECTANGLE):BOOLEAN;
begin
     Rect.x1 := 300;
     Rect.y1 := 420;
     Rect.x2 := 630;
     Rect.y2 := 430;
     BoundInfoPic := TRUE;
end;

procedure DrawInfoPic(num:integer; var Match:typeMATCH_STATE);
begin
   setcolor(13);
   OutTextXY(300,420,Match.strInfo);
end;

function BoundPlayerPic(num:integer; var Match:typeMATCH_STATE; var Rect:typeRECTANGLE):BOOLEAN;
var r:integer;
begin
     t(Match.Players[num].PositionX,Match.Players[num].PositionY,0,Rect.x1,Rect.y1);
     r := 16;
     Rect.x1 := Rect.x1-16;
     Rect.y1 := Rect.y1-16;
     Rect.x2 := Rect.x1 + 2*16;
     Rect.y2 := Rect.y1 + 2*16;


     if (Match.Players[num].Role = ROLE_PRE_SERVICE) or
        (Match.Players[num].Role = ROLE_PRE_RETURN) or
        (Match.Players[num].Role = ROLE_PRE_NET_PLAYER) then
           inc(Rect.x2,10+TextWidth(Settings.Players[Match.Players[num].PlayerNo].strName));

     BoundPlayerPic := TRUE;
end;

procedure DrawPlayerPic(num:integer; var Match:typeMATCH_STATE);
var name:STRING;
    x,y,r:integer;
begin
   setcolor(Settings.Players[Match.Players[num].PlayerNo].Color);
   t(Match.Players[num].PositionX,Match.Players[num].PositionY,0,x,y);
   r := d(Settings.Players[Match.Players[num].PlayerNo].Radius)+1;

   putimage(x-15,y-15,pPics[Match.Players[num].PlayerNo]^,NormalPut);


   if (Match.Players[num].Role = ROLE_PRE_SERVICE) or
      (Match.Players[num].Role = ROLE_PRE_RETURN) or
      (Match.Players[num].Role = ROLE_PRE_NET_PLAYER) then
         OutTextXY(x+r+4,y,Settings.Players[Match.Players[num].PlayerNo].strName);
end;

function BoundBallPic(num:integer; var Match:typeMATCH_STATE; var Rect:typeRECTANGLE):BOOLEAN;
begin
     t(Match.BallX,Match.BallY,0,Rect.x1,Rect.y1);
     Rect.x1 := Rect.x1-2;
     Rect.y1 := Rect.y1-2;
     Rect.x2 := Rect.x1 + 4;
     Rect.y2 := Rect.y1 + 4;
     BoundBallPic := TRUE;
end;

procedure DrawBallPic(num:integer; var Match:typeMATCH_STATE);
var x,y:integer;
begin
     t(Match.BallX,Match.BallY,0,x,y);
     PutPixel(x,y,11);
     PutPixel(x+1,y,11);
     PutPixel(x-1,y,11);
     PutPixel(x,y+1,11);
     PutPixel(x,y-1,11);
end;


function BoundDebugPlayer(num:integer; var Match:typeMATCH_STATE; var Rect:typeRECTANGLE):BOOLEAN;
begin
     Rect.x1 := 300;
     Rect.y1 := 300+16*num;
     Rect.x2 := 600;
     Rect.y2 := Rect.y1+16;
     BoundDebugPlayer := TRUE;
end;

procedure DrawDebugPlayer(num:integer; var Match:typeMATCH_STATE);
var x,y:integer;
  Text:string;
begin
       setcolor(Settings.Players[Match.Players[num].PlayerNo].Color);
       x := 300;
       y := 300+16*num;
       str(Match.Players[num].PlayerNo,Text);
       if Match.Players[num].Position = SIDE_LEFT then
           Text := Text + ' L'
       else
           Text := Text + ' R';
       case Match.Players[num].HandHold of
HAND_STAND_BY:        Text := Text + ' HAND_STAND_BY';
HAND_FOREHAND:        Text := Text + ' HAND_FOREHAND';
HAND_BACKHAND:        Text := Text + ' HAND_BACKHAND';
HAND_SMASH:           Text := Text + ' HAND_SMASH';
HAND_STOPBALL:        Text := Text + ' HAND_STOPBALL';
HAND_LOB:             Text := Text + ' HAND_LOB';
HAND_SERVICE:         Text := Text + ' HAND_SERVICE';
HAND_PUNCH:           Text := Text + ' HAND_PUNCH';
       end;
       case Match.Players[num].Role of
ROLE_WAIT:               Text := Text + ' ROLE_WAIT';
ROLE_PRE_SERVICE:        Text := Text + ' ROLE_PRE_SERVICE';
ROLE_PRE_NET_PLAYER:     Text := Text + ' ROLE_PRE_NET_PLAYER';
ROLE_PRE_RETURN:         Text := Text + ' ROLE_PRE_RETURN';
ROLE_SERVICE:            Text := Text + ' ROLE_SERVICE';
ROLE_RETURN:             Text := Text + ' ROLE_RETURN';
ROLE_NET_PLAYER:         Text := Text + ' ROLE_NET_PLAYER';
ROLE_BACK_PLAYER:        Text := Text + ' ROLE_BACK_PLAYER';
       end;
     OutTextXY(x,y,Text);
end;

function BoundDebugJudge(num:integer; var Match:typeMATCH_STATE; var Rect:typeRECTANGLE):BOOLEAN;
begin
     Rect.x1 := 300;
     Rect.y1 := 400;
     Rect.x2 := 600;
     Rect.y2 := 420;
     BoundDebugJudge := TRUE;
end;

procedure DrawDebugJudge(num:integer; var Match:typeMATCH_STATE);
var x,y:integer;
begin
     x := 300;
     y := 400;
     case Match.JudgeSad of
JUDGE_NOTHING:                OutTextXY(x,y, 'JudgeSad = JUDGE_NOTHING');
JUDGE_OUT:                    OutTextXY(x,y, 'JudgeSad = JUDGE_OUT');
JUDGE_LOST:                   OutTextXY(x,y, 'JudgeSad = JUDGE_LOST');
JUDGE_NET:                    OutTextXY(x,y, 'JudgeSad = JUDGE_NET');
JUDGE_SERVICE_OUT:            OutTextXY(x,y, 'JudgeSad = JUDGE_SERVICE_OUT');
JUDGE_SERVICE_NET:            OutTextXY(x,y, 'JudgeSad = JUDGE_SERVICE_NET');
JUDGE_SERVICE_FOOT_FAULT:     OutTextXY(x,y, 'JudgeSad = JUDGE_SERVICE_FOOT_FAULT');
JUDGE_SERVICE_TIMEOUT:        OutTextXY(x,y, 'JudgeSad = JUDGE_SERVICE_TIMEOUT');
JUDGE_FOOT_FAULT:             OutTextXY(x,y, 'JudgeSad = JUDGE_FOOT_FAULT');
     end;
end;

function BoundDebugEvent(num:integer; var Match:typeMATCH_STATE; var Rect:typeRECTANGLE):BOOLEAN;
begin
     Rect.x1 := 300;
     Rect.y1 := 420;
     Rect.x2 := 600;
     Rect.y2 := 440;
     BoundDebugEvent := TRUE;
end;

procedure DrawDebugEvent(num:integer; var Match:typeMATCH_STATE);
var x,y:integer;
begin
     x := 300;
     y := 420;
     case Match.Event of
EVENT_NONE:    ;
EVENT_HIT_BALL:           OutTextXY(x,y, 'Event = EVENT_HIT_BALL');
EVENT_JUMPED_BALL:        OutTextXY(x,y, 'Event = EVENT_JUMPED_BALL');
EVENT_SCORED:             OutTextXY(x,y, 'Event = EVENT_SCORED');
EVENT_BEGIN_PLAY:         OutTextXY(x,y, 'Event = EVENT_BEGIN_PLAY');
     end;
     if Match.Event <> EVENT_NONE then begin
        sound(500);
        delay(20);
        nosound;
     end;
end;

function BoundDebugWhereBall(num:integer; var Match:typeMATCH_STATE; var Rect:typeRECTANGLE):BOOLEAN;
begin
     Rect.x1 := 300;
     Rect.y1 := 440;
     Rect.x2 := 600;
     Rect.y2 := 460;
     BoundDebugWhereBall := TRUE;
end;

procedure DrawDebugWhereBall(num:integer; var Match:typeMATCH_STATE);
var x,y:integer;
begin
     x := 300;
     y := 440;
     case Match.WhereBall of
WHEREBALL_SERVER_HAS:          OutTextXY(x,y, 'WhereBall = WHEREBALL_SERVER_HAS');
WHEREBALL_YOU_HIT:             OutTextXY(x,y, 'WhereBall = WHEREBALL_YOU_HIT');
WHEREBALL_ENEMY_HIT:           OutTextXY(x,y, 'WhereBall = WHEREBALL_ENEMY_HIT');
WHEREBALL_YOU_ONCE_DROPED:     OutTextXY(x,y, 'WhereBall = WHEREBALL_YOU_ONCE_DROPPED');
WHEREBALL_ENEMY_ONCE_DROPED:   OutTextXY(x,y, 'WhereBall = WHEREBALL_ENEMY_ONCE_DROPED');
WHEREBALL_OUT_OF_GAME:         OutTextXY(x,y, 'WhereBall = WHEREBALL_OUT_OF_GAME');
WHEREBALL_YOU_SERVER_HIT:      OutTextXY(x,y, 'WhereBall = WHEREBALL_YOU_SERVER_HIT');
WHEREBALL_ENEMY_SERVER_HIT:    OutTextXY(x,y, 'WhereBall = WHEREBALL_ENEMY_SERVER_HIT');
     end;
end;

begin
   size:= 470;
   for i := 1 to Settings.nPlayers do
   begin
      str(i,strN);
      assign(InFile,'player'+strN+'.pic');
      reset(InFile,1);
      getmem(pPics[i],size);
      blockread(InFile,pPics[i]^,size);
      close(InFile);
   end;
end.