Unit MyGraph;

interface

Uses
    Types,Graph,uSprite,Draw2d,DrawPic,Setting;

procedure HovnoHovnoZlataRybka;
procedure InitGraphics( DisplayMode:integer );
procedure CloseGraphics;
procedure ResetSprites;

implementation

procedure ResetPalette(meno:string);
var i:integer;
var r,g,b:byte;
    j:integer;
    pocetf:byte;
    sirka,vyska:word;
   pp1:file;
    NW1,NW2,NW3,NW4,size:word;
begin
 for i:=0 to 15 do
     setpalette(i,i);

 assign(pp1,meno);
 reset(pp1,1);
 blockread(pp1,sirka,2,NW1);
 blockread(pp1,vyska,2,NW1);
 blockread(pp1,pocetf,1,NW1);
 for i:=0 to pocetf-1 do
 begin
  blockread(pp1,r,1,NW1);
  blockread(pp1,g,1,NW2);
  blockread(pp1,b,1,NW3);
  setrgbpalette(i,r,g,b);
 end;
end;

procedure HovnoHovnoZlataRybka;
begin
   asm int 3; end;
   { Yeah, this is an internal program error }
   { Contact your local vendor               }
   writeln('Shit...Internal Error');
   Halt;
end;

procedure InitGraphics( DisplayMode:integer );
var gd,gm:integer;
    i:integer;
    Sprite:typeSPRITE;
begin
    DetectGraph(gd,gm);
    InitGraph(gd,gm,'.');

    ResetPalette('al.pic');

    ResetSprites;

end;

procedure ResetSprites;
var i:integer;
    Sprite:typeSPRITE;
begin

    if (Settings.DisplayMode = DISPLAY_2D) then
    begin
       FnDrawBack := DrawBack2d;
       for i := 1 to 4 do begin
           Sprite.num := i;
           Sprite.FnBound := BoundPlayer2d;
           Sprite.FnDraw := DrawPlayer2d;
           AddSprite(Sprite);
       end;
       Sprite.FnBound := BoundBall2d;
       Sprite.FnDraw := DrawBall2d;
       AddSprite(Sprite);

       Sprite.FnBound := BoundScore2d;
       Sprite.FnDraw := DrawScore2d;
       AddTurnSprite(Sprite);

       Sprite.FnBound := BoundInfo2d;
       Sprite.FnDraw := DrawInfo2d;
       AddTurnSprite(Sprite);

       if Settings.bDebugOutput then begin
         Sprite.FnBound := BoundDebugJudge;
         Sprite.FnDraw := DrawDebugJudge;
         AddSprite(Sprite);

         Sprite.FnBound := BoundDebugEvent;
         Sprite.FnDraw := DrawDebugEvent;
         AddSprite(Sprite);

         Sprite.FnBound := BoundDebugWhereBall;
         Sprite.FnDraw := DrawDebugWhereBall;
         AddSprite(Sprite);

         for i := 1 to 4 do begin
            Sprite.num := i;
            Sprite.FnBound := BoundDebugPlayer;
            Sprite.FnDraw := DrawDebugPlayer;
            AddSprite(Sprite);
         end;
       end;
    end;

    if (Settings.DisplayMode = DISPLAY_PIC) then
    begin
       FnDrawBack := DrawBackPic;
       for i := 1 to 4 do begin
           Sprite.num := i;
           Sprite.FnBound := BoundPlayerPic;
           Sprite.FnDraw := DrawPlayerPic;
           AddSprite(Sprite);
       end;
       Sprite.FnBound := BoundBallPic;
       Sprite.FnDraw := DrawBallPic;
       AddSprite(Sprite);

       Sprite.FnBound := BoundScorePic;
       Sprite.FnDraw := DrawScorePic;
       AddTurnSprite(Sprite);

       Sprite.FnBound := BoundInfoPic;
       Sprite.FnDraw := DrawInfoPic;
       AddTurnSprite(Sprite);

       if Settings.bDebugOutput then begin
         Sprite.FnBound := BoundDebugJudge;
         Sprite.FnDraw := DrawDebugJudge;
         AddSprite(Sprite);

         Sprite.FnBound := BoundDebugEvent;
         Sprite.FnDraw := DrawDebugEvent;
         AddSprite(Sprite);

         Sprite.FnBound := BoundDebugWhereBall;
         Sprite.FnDraw := DrawDebugWhereBall;
         AddSprite(Sprite);

         for i := 1 to 4 do begin
            Sprite.num := i;
            Sprite.FnBound := BoundDebugPlayer;
            Sprite.FnDraw := DrawDebugPlayer;
            AddSprite(Sprite);
         end;
       end;
    end;
end;

procedure CloseGraphics;
begin
    CloseGraph;
end;


end.