Unit Player5;

interface

   uses Types,crt;

   function GetName:string;
   function InitSession( iPlayer:integer ):string;
   function InitMatch(var Match:typeMATCH_STATE):string;
   procedure Compute(var Match:typeMATCH_STATE; var Action:typeACTION);

implementation

function GetName:string;
begin
    GetName := 'Player 5';
end;

function InitSession( iPlayer:integer ):string;
begin
     InitSession := 'CHODTE DO KELU';
end;

function InitMatch( var Match:typeMATCH_STATE ):string;
begin
     InitMatch := 'PAZA';
end;

function dist(x1,y1,x2,y2:real):real;
begin
  dist:=sqrt(sqr(x2-x1)+sqr(y2-y1));
end;

procedure ChoosePoint(px,py,bx,by,ax,ay:real;var Action:typeACTION);
var dx,dy,x,y:real;
begin

     dx := ax-bx;
     dy := ay-by;
     VectMaxInDir(dx,dy,Settings.AlgerianPlayerRadius);

     x := bx-dx;
     y := by-dy;

    Action.VelocityX := (x - px)*15;
    Action.VelocityY := (y - py)*15;
end;

function min(x,y:real):real;
begin
    if (x<y) then
       min := x
    else
       min := y;
end;

procedure Compute( var Match:typeMATCH_STATE; var Action:typeACTION);
var  me:^typePLAYER_STATE;
var a,b,m:real;
var aa,bb,cc,t1,t2,d,dt,t:real;
begin
    {!!!!! A EXAMPLE !!!!!!}

    me := @(Match.Players[1]); { Players[1] - that's me                     }
                               { Players[2] - that's my friend              }
                               { Players[3], Player[4] - that are my enemies}
    me^.bFreeWill := FALSE;     { Did not decided what action to preform,yet }
                               { so we are satisfied with the default subtit}

    case me^.Role of            { Depending upon my role ...                 }
      ROLE_BACK_PLAYER,
      ROLE_NET_PLAYER:
      begin
          { I AM PLAYING }

          if (Match.WhereBall = WHEREBALL_ENEMY_HIT) or
             (Match.WhereBall = WHEREBALL_ENEMY_SERVER_HIT) then
          begin
              { THE BALLS FLIES ONTO ME }
              me^.bFreeWill := TRUE;{ I want to preform my own action            }

              { Let's meet the ball }

              { Parameters of the ball's path }
              a := Match.BallVY;
              b := (-1)*Match.BallVX;
              { The multiplication factor }
              m := a*Match.BallX + b*Match.BallY - a*me^.PositionX - b*me^.PositionY;

              dt := Settings.TimeStep*Settings.nStepsPerCount;

              aa := sqr(Match.BallVX)+sqr(Match.BallVY) - sqr(Settings.AlgerianMaxPlayerSpeed);
              bb := 2*((Match.BallX-me^.PositionX)*Match.BallVX+(Match.BallY-me^.PositionY)*Match.BallVY);
              cc := sqr(Match.BallX-me^.PositionX)+sqr(Match.BallY-me^.PositionY);

              d  := sqr(bb)-4*aa*cc;
              if (d > 0) then
              begin
                t1 := (-bb-sqrt(d))/2/aa;
                t2 := (-bb+sqrt(d))/2/aa;

                t := min(t1,t2);

                if random(2) = 0 then
                ChoosePoint(me^.PositionX,me^.PositionY,Match.BallX+t*Match.BallVX,Match.BallY+t*Match.BallVY,
                    Settings.GroundX1,Settings.AlgerianD+Settings.NetY,Action)
                else
                ChoosePoint(me^.PositionX,me^.PositionY,Match.BallX+t*Match.BallVX,Match.BallY+t*Match.BallVY,
                    Settings.GroundX2,Settings.AlgerianD+Settings.NetY,Action);

{                    Settings.GroundAxisX,Settings.AlgerianY2,Action);}
              end
              else
              begin

                  if  (me^.Position = SIDE_LEFT) then
                      a := (Settings.GroundAxisX+Settings.GroundX1)/2
                  else
                      a := (Settings.GroundAxisX+Settings.GroundX2)/2;
                  b := Settings.NetY - Settings.AlgerianD - 2;

                  Action.VelocityX := (a - me^.PositionX)*15;
                  Action.VelocityY := (b - me^.PositionY)*15;
              end;

(*              mx:=me^.positionx; my:=me^.positiony; {my position}



              {bx,by}
              bx := Match.BallX;
              by := Match.BallY;
              bvx:=match.ballvx; bvy:=match.ballvy;
              tk:=1/(settings.timestep*settings.nstepspercount);
              ls:=(1/tk)*settings.maxplayerspeed;
              ttk:=0; success:=false;
              while (ttk<10*tk) or not success do begin
                dbx:=dx+bvx; dby:=dy+bvy; {db - new coord of the ball}
                if dist(dbx,dby,mx,my)<ls*ttk-res then begin
                  if tk>3 then begin
                    tk:=tk/2; bvx:=bvx/2; bvy:=bvy/2;
                  end else begin
                    bx:=dbx; by;=dby; {we've got a reachable ball position}
                    ttk:=ttk+tk;
                    success:=true;
                  end;
                end else begin
                end;
              end;

              end;*)

          end;
      end;
    end;


end;


end.
