{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
{ Proboj '98-jar }

{$F+}

program Proboj;

uses
    graph,Intro,
    crt,dos,
    Types,
    uSprite,Setting,MyGraph,uMatch,KbWatch,uSound;

procedure Tournament; FORWARD;


procedure main;
var i:integer;
begin

    initRecording; {initialize GUS }

    InitGraphics(Settings.DisplayMode);

    if (Settings.bIntro) then
        StartIntro;

    KbInit;

    { Play tournamet if we have to }
    if (Settings.GameMode = GAME_TOURNAMENT) then
       Tournament;

    KbFree;

    KbClose;

    CloseGraphics;

    closeRecording;
end;

procedure Tournament;
var
    iActualMatch:integer;
    i:integer;
    ArchiveFile:text;
    Hour,Minute,Sec,Sec100:word;
begin
    {Begin Tournament}

    {Clear the archive file}
    assign(ArchiveFile,Settings.strScoreFile);
    rewrite(ArchiveFile);
    writeln(ArchiveFile,'Tournament archive file');
    GetTime(Hour,Minute,Sec,Sec100);
    writeln(ArchiveFile,Hour,':',Minute,':',Sec,'.',Sec100);

    close(ArchiveFile);


    { Ask for the player's names }
    for i := 1 to Settings.nPlayers do
        Settings.Players[i].strName := Settings.Players[i].FnGetName;
    { Call the player's InitSession function }
    for i := 1 to Settings.nPlayers do
        Settings.Players[i].FnInitSession(i);


    { Play matches acordimg to schedule }
    for iActualMatch := 1 to Settings.nMatches do
    begin
        {Match}

        Match(iActualMatch);

        if KbIsPressed(61) then
        begin
            KbFree;
            break;
        end;

    end;

end;

begin
    Main;
end.