Unit Wtplay;

interface

   uses Types,crt;

   function GetName:string;
   function InitSession( iPlayer:integer ):string;
   function InitMatch(var Match:typeMATCH_STATE):string;
   procedure Compute(var Match:typeMATCH_STATE; var Action:typeACTION);

implementation

function GetName:string;
begin
    GetName := 'Wait Player';
end;

function InitSession( iPlayer:integer ):string;
begin
     InitSession := 'CHODTE DO KELU';
end;

function InitMatch( var Match:typeMATCH_STATE ):string;
begin
     InitMatch := 'PAZA';
end;

procedure Compute( var Match:typeMATCH_STATE; var Action:typeACTION);
var  me:^typePLAYER_STATE;
var a,b,m:real;
begin
    Types.Wait(Settings.MaxComputeDuration/10*9);
    {!!!!! A EXAMPLE !!!!!!}

    me := @(Match.Players[1]); { Players[1] - that's me                     }
                               { Players[2] - that's my friend              }
                               { Players[3], Player[4] - that are my enemies}
    me^.bFreeWill := FALSE;     { Did not decided what action to preform,yet }
                               { so we are satisfied with the default subtit}

    case me^.Role of            { Depending upon my role ...                 }
      ROLE_BACK_PLAYER,
      ROLE_NET_PLAYER:
      begin
          { I AM PLAYING }

          if (Match.WhereBall = WHEREBALL_ENEMY_HIT) or
             (Match.WhereBall = WHEREBALL_ENEMY_SERVER_HIT) then
          begin
              { THE BALLS FLIES ONTO ME }
              me^.bFreeWill := TRUE;{ I want to preform my own action            }

              { Let's meet the ball }

              { Parameters of the ball's path }
              a := Match.BallVY;
              b := (-1)*Match.BallVX;
              { The multiplication factor }
              m := a*Match.BallX + b*Match.BallY - a*me^.PositionX - b*me^.PositionY;

              Action.VelocityX := a*5*m;
              Action.VelocityY := b*5*m;
          end;
      end;
    end;


end;


end.